const request = require('request');
const crypto = require('crypto');

const config = {
    url: 'https://live2.moduyun.com/sms/v2/sendsinglesms',

    accesskey: '', // 根据实际填 accesskey
    secretkey: '', // 根据实际填 secretkey
};

let SMSSender = {
    getRandom(lower = 100000, upper = 999999) {
        return Math.floor(Math.random() * (upper - lower)) + lower;
    },
    sig(random, curTime, phoneNumber) {
        let hash = crypto.createHash('sha256');

        hash.update('secretkey=' + config.secretkey +
            '&random=' + random +
            '&time=' + curTime +
            '&mobile=' + phoneNumber);

        return hash.digest('hex').toUpperCase();
    },
    send(templateId, signId, parameter, type, phoneNumber, nationCode) {
        let self = this;

        let curTime = Math.floor(Date.now() / 1000);
        let random = self.getRandom();
        let tel = {
            "nationcode": nationCode,
            "mobile": phoneNumber
        };
        let data = {
            "sig": self.sig(random, curTime, phoneNumber),
            "time": curTime,
            "signId": signId,
            "parameter": parameter,
            "templateId": templateId,
            "tel": tel,
            "type": 0,
            "ext": '',
            "extend": '',
        };
        var bodyString = JSON.stringify(data);
        console.log(bodyString);
        request({
            url: config.url + '?accesskey=' + config.accesskey + '&random=' + random,
            headers: {
                'Content-Type': 'application/json',
                'Content-Length': bodyString.length
            },
            method: 'POST',
            json: true,
            body: data
        }, (err, res, body) => {
            if (err) {
                console.log(err);
                return;
            }
            console.log(body);
        });
    },
    test() {
        let code = this.getRandom();
        let templateId = ""; //模板ID
        let signId = ""; //签名Id
        let parameter = ["914379"]; //参数数组
        let type = 0; //类型
        let phoneNumber = ""; //手机号码
        let nationCode = "86"; //区号
        this.send(templateId, signId, parameter, type, phoneNumber, nationCode);
    }
};

SMSSender.test();

module.exports = SMSSender;